if(!com) var com={};
if(!com.clipta) com.clipta={};
if(!com.clipta.file) com.clipta.file={}
//CliptaFileUtls:
com.clipta.file.CliptaFileUtils={
	lastProfilePath:null,
	getProfilePath:function(){
		if(this.lastProfilePath) return this.lastProfilePath
		try {
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		} catch (e) {
			//LOG("Permission to save file was denied.");
		}
		// get the path to the user's home (profile) directory
		const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
		var path='';
		try { 
			path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path; 
		} catch (e) {
			//LOG("error");
			return false;
		}
		// determine the file-separator
		if (path.search(/\\/) != -1) {
			path = path + "\\extensions\\cliptatoolbar@clipta.com\\";
			//path = path + "\\extensions\\";
		} else {
			path = path + "/extensions/cliptatoolbar@clipta.com/";
			//path = path + "/extensions/";
		}
		this.lastProfilePath = path
		return path;

	},
	fileExists:function(filename){
		try {
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		} catch (e) {
			//LOG("Permission to access file was denied.");
			return false;
		}
		var file = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath( this.getProfilePath()+filename );
		return file.exists()
	},
	save:function(filename,content) {
		try {
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		} catch (e) {
			//LOG("Permission to save file was denied.");
			return false;
		}
		var file = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath( this.getProfilePath()+filename );
		if (!file.exists()){
			file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 511 );
		}
		
		var fos = Components.classes["@mozilla.org/network/file-output-stream;1"]
			.createInstance( Components.interfaces.nsIFileOutputStream );
		fos.init( file, 0x04 | 0x08 | 0x20, 420, 0 );
		// for UTF-8:
		var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
                   .createInstance(Components.interfaces.nsIConverterOutputStream);
		os.init(fos, "UTF-8", 0, 0x0000);
		os.writeString(content);
		os.close();

		//var result = outputStream.write( content, content.length );
		fos.close();
		return true
	},
	read:function(filename) {
		try {
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		} catch (e) {
			//LOG("Permission to read file was denied.");
			return false;
		}
		var file = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath( this.getProfilePath()+filename );
		if ( file.exists() == false ) {
			//LOG("File does not exist");
			return false;
		}
		var is = Components.classes["@mozilla.org/network/file-input-stream;1"]
			.createInstance( Components.interfaces.nsIFileInputStream );
		is.init( file,0x01, 00004, null);
		var sis = Components.classes["@mozilla.org/scriptableinputstream;1"]
			.createInstance( Components.interfaces.nsIScriptableInputStream );
		sis.init( is );

		var output = sis.read( sis.available() );
		var utf8Converter = Components.classes["@mozilla.org/intl/utf8converterservice;1"].
				getService(Components.interfaces.nsIUTF8ConverterService);
		var output = utf8Converter.convertURISpecToUTF8 (output, "UTF-8"); 
		this.lastContent=output;
		return output;
	},
	getLastModifyDate:function(filename){
		try {
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		} catch (e) {
			//LOG("Permission to read file was denied.");
			return false;
		}
		var file = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath( this.getProfilePath()+filename );
		if ( file.exists() == false ) {
			//LOG("File does not exist");
			return false;
		}
		return file.lastModifiedTime;
		
	}

}

